﻿Imports System.Text
Imports System.IO


Public Class VBMIDIForm
    Dim s(7) As Integer
    Dim x As Int64
    Dim xx As Int64
    Dim xend As Int64
    Dim xstart As Int64

    Dim startoff As Int64

    Private Song As New MIDI
    ' Private Notes As New Collection
    'Const NumberOfNotes As Integer = 128

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        x = 0
        xx = 0
        xstart = 0
        xend = 0
        s(0) = 60 'middle c ==========================
        s(1) = 62
        s(2) = 64
        s(3) = 65
        s(4) = 67
        s(5) = 69
        s(6) = 71
        Song.AddTrack()
    End Sub

    Private Sub Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Save.Click
        Dim mtracks As Integer
        mtracks = 1
        Song.Tracks(0).TrackData.Clear()
        If GenerateTrack(0) Then
            'nothing
        End If
        Directory.SetCurrentDirectory(Directory.GetCurrentDirectory)
        Dim myfile As String
        myfile = "CMAJ.MID"
        Me.SaveMIDIDialog.DefaultExt = "MID"
        Me.SaveMIDIDialog.FileName = My.Computer.FileSystem.CombinePath(My.Computer.FileSystem.SpecialDirectories.MyDocuments, myfile)
        Me.SaveMIDIDialog.FileName = My.Computer.FileSystem.CombinePath(My.Computer.FileSystem.CurrentDirectory, myfile)
        Me.SaveMIDIDialog.InitialDirectory = My.Computer.FileSystem.CurrentDirectory
        Me.SaveMIDIDialog.Filter = "VB MIDI files (*.MID)|*.MID"
        Dim result As DialogResult = Me.SaveMIDIDialog.ShowDialog
        If result = DialogResult.OK Then
            Song.Save(SaveMIDIDialog.FileName)
        End If
    End Sub
    Private Function GenerateTrack(ByVal index As Integer) As Boolean
        'MsgBox(index)
        Dim restBeats As Double = 0.0
        Dim beats As Double = 0.0
        Dim volume As Integer = 127
        Dim temp As String
        temp = TextBox1.Text ' set start and end notes
        xend = Val(temp)
        temp = TextBox2.Text
        xstart = Val(temp)



        x = 0
        '***********************************************
        beats = 3.0  ' 200 bpm  (200.0000347)
        volume = 127

        For c1 = 0 To 6
            For c2 = 0 To 6
                For c3 = 0 To 6
                    For c4 = 0 To 6
                        For c5 = 0 To 6
                            For c6 = 0 To 6
                                For c7 = 0 To 6
                                    'ignore until start
                                    If xstart > 0 Then
                                        If xx < xstart Then
                                            GoTo jump1
                                        Else
                                            xstart = 0 ' turn off start chk
                                            x = 0      ' count written notes
                                        End If
                                    End If

                                    'MsgBox("writing note")
                                    Song.Tracks(index).AddNoteOnOffEvent(restBeats, MIDI.Track.NoteEvent.NoteOn, CByte(s(c7)), CByte(volume))
                                    Song.Tracks(index).AddNoteOnOffEvent(beats, MIDI.Track.NoteEvent.NoteOff, CByte(s(c7)), 0)
                                    '
                                    Song.Tracks(index).AddNoteOnOffEvent(restBeats, MIDI.Track.NoteEvent.NoteOn, CByte(s(c6)), CByte(volume))
                                    Song.Tracks(index).AddNoteOnOffEvent(beats, MIDI.Track.NoteEvent.NoteOff, CByte(s(c6)), 0)

                                    Song.Tracks(index).AddNoteOnOffEvent(restBeats, MIDI.Track.NoteEvent.NoteOn, CByte(s(c5)), CByte(volume))
                                    Song.Tracks(index).AddNoteOnOffEvent(beats, MIDI.Track.NoteEvent.NoteOff, CByte(s(c5)), 0)
                                    '
                                    Song.Tracks(index).AddNoteOnOffEvent(restBeats, MIDI.Track.NoteEvent.NoteOn, CByte(s(c4)), CByte(volume))
                                    Song.Tracks(index).AddNoteOnOffEvent(beats, MIDI.Track.NoteEvent.NoteOff, CByte(s(c4)), 0)

                                    Song.Tracks(index).AddNoteOnOffEvent(restBeats, MIDI.Track.NoteEvent.NoteOn, CByte(s(c3)), CByte(volume))
                                    Song.Tracks(index).AddNoteOnOffEvent(beats, MIDI.Track.NoteEvent.NoteOff, CByte(s(c3)), 0)
                                    '
                                    Song.Tracks(index).AddNoteOnOffEvent(restBeats, MIDI.Track.NoteEvent.NoteOn, CByte(s(c2)), CByte(volume))
                                    Song.Tracks(index).AddNoteOnOffEvent(beats, MIDI.Track.NoteEvent.NoteOff, CByte(s(c2)), 0)

                                    Song.Tracks(index).AddNoteOnOffEvent(restBeats, MIDI.Track.NoteEvent.NoteOn, CByte(s(c1)), CByte(volume))
                                    Song.Tracks(index).AddNoteOnOffEvent(beats, MIDI.Track.NoteEvent.NoteOff, CByte(s(c1)), 0)
                                    '

                                    x = x + 7 ' notes actually written!
jump1:
                                    xx = xx + 7 ' all notes including unwritten
                                    If xend > 0 Then
                                        If x > xend Then
                                            MsgBox("Ending after " & x & "  Notes")
                                            Return True
                                        End If
                                    End If

                                Next
                            Next
                        Next
                    Next
                Next
            Next
        Next
        MsgBox(x)
        Return True
    End Function
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        End
    End Sub


    Private Sub TextBox3_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox3.TextChanged
        Dim temp As String
        temp = TextBox3.Text
        startoff = Val(temp)
        If startoff > 499 Then startoff = 0
        startoff = startoff * 11545.794392523365
        Label5.Text = "Start note = " & startoff.ToString
        TextBox2.Text = startoff.ToString
    End Sub
End Class
